/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.scene.MonsterInfo
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.sPos.BasicPos
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 */
package fire.pb.scene.movable;

import fire.pb.scene.MonsterInfo;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneManager;
import fire.pb.scene.movable.SceneObject;
import fire.pb.scene.sPos.BasicPos;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;

public abstract class Body
extends SceneObject {
    private int dir;
    private Position curDestPos = null;
    private int speed = this.getStandardSpeed();

    Body(long uid, String nm, Scene s, Position p, int d) {
        super(uid, nm, s, p);
        this.dir = d;
    }

    final int getDir() {
        return this.dir;
    }

    public final void setDir(int d) {
        this.dir = d < 0 || d > 7 ? this.dir : d;
    }

    public final void setCurDestPos(int x, int y) {
        this.curDestPos = new Position(x, y);
    }

    final Position getCurDestPos() {
        return this.curDestPos;
    }

    public final void clearCurDestPos() {
        this.curDestPos = null;
    }

    public final void enterMyScreen() {
        this.enterMyScreen(-1);
    }

    public final void leaveMyScreen() {
        this.leaveMyScreen(-1);
    }

    public abstract void notifySeeEachother(int var1);

    public abstract void notifyForgetEachother(int var1, boolean var2);

    public final void enterMyScreen(int dir) {
        if (0 == dir) {
            return;
        }
        Scene scene = this.getScene();
        if (null == scene) {
            return;
        }
        scene.addBodyToScreen(this);
        this.notifySeeEachother(dir);
    }

    public final void leaveMyScreen(int dir) {
        if (0 == dir) {
            return;
        }
        Scene scene = this.getScene();
        if (null == scene) {
            return;
        }
        this.notifyForgetEachother(dir, true);
        scene.removeBodyFromScreen(this);
    }

    public final int getMonsterConfig() {
        if (null == this.getScene()) {
            return 0;
        }
        MonsterInfo m = this.getScene().getMapInfo().getMonsterInfo();
        if (null == m) {
            return 0;
        }
        GridPos g = this.getPos().toGridPos();
        return m.getMonsterConfig(g.getX(), g.getY());
    }

    public boolean updatePosition(Position p) {
        Scene s = this.getScene();
        if (null == s) {
            return false;
        }
        if (!s.validPosition(p)) {
            SceneManager.logger.error((Object)("updatePosition移动时坐标不合法：MapId=" + s.getMapID() + ",Pos=" + p));
            return false;
        }
        int dir = this.getMyScreenPos().where((BasicPos)s.getScreenPos(p));
        this.leaveMyScreen(dir);
        this.setPos(p);
        this.enterMyScreen(dir);
        return true;
    }

    public boolean updatePosition(Scene ns, Position np) {
        if (null == ns) {
            return false;
        }
        if (null == np) {
            return false;
        }
        if (!ns.validPosition(np)) {
            SceneManager.logger.error((Object)("updatePosition跳转时坐标不合法：MapId=" + ns.getMapID() + ",Pos=" + np));
            return false;
        }
        this.leaveMyScreen();
        this.setScene(ns);
        this.setPos(np);
        this.clearCurDestPos();
        this.enterMyScreen();
        return true;
    }

    public boolean updatePositionForce(Position p) {
        Scene s = this.getScene();
        if (null == s) {
            return false;
        }
        if (!s.validPosition(p)) {
            SceneManager.logger.error((Object)("updatePosition移动时坐标不合法：MapId=" + s.getMapID() + ",Pos=" + p));
            return false;
        }
        this.leaveMyScreen(-1);
        this.setPos(p);
        this.enterMyScreen(-1);
        return true;
    }

    public final int getStandardSpeed() {
        return 140;
    }

    public final int getSpeed() {
        return this.speed;
    }

    public final void setSpeed(int val) {
        this.speed = val;
    }
}

